#include "map.h"

#include <stdarg.h>
#include <stdio.h>
#include <allegro.h>
#include <dpmi.h>
#include "global.h"

void InitMap()
{
    int TLoopX = 0, TLoopY = 0, TCounter = 0;
    text_mode(-1);
    tilebmp = load_bitmap("GFX\\maptiles.bmp", pallete);
    if (screenbmp == NULL)
       die ("Couldn't load GFX\\maptiles.bmp");
    screenbmp = load_bitmap("GFX\\maptiles.bmp", pallete);
    if (screenbmp == NULL)
       die ("Couldn't load GFX\\maptiles.bmp");
    set_pallete(pallete);
    for (TCounter = 0; TCounter <= 250; TCounter++)	// Initializes the Tiles
       tile[TCounter] = load_bitmap("GFX\\white.bmp", pallete);
    LoadMapTiles();		// Loads the map tiles
    LoadFile();			// loads the map file
    DrawMap();
}

void DrawExtras()		// Draws the stuff that tells the user where he is on the map
 {
    int TLoopY, TLoopX;
    masked_blit(tile[(20 + User.dir)], screen, 0, 0, (12 * 16), (5 * 16), 16, 16);
}

void LoadMapTiles()
{
    int TCounter, TLoopY, TLoopX;

    TCounter = 0;
    for (TLoopY = 0; TLoopY < 176; TLoopY += 16) {	//Puts the tiles into memory
       for (TLoopX = 0; TLoopX < 314; TLoopX += 16) {
          blit(tilebmp, tile[TCounter], TLoopX, TLoopY, 0, 0, 16, 16);
          TCounter += 1;
       }
    }
}

void DrawMap()
{
    int TCounter, TLoopY, TLoopX;

    TCounter = 0;
    for (TLoopY = 0; TLoopY < 13; TLoopY++) {	// displays the map on the screen
       for (TLoopX = 0; TLoopX < 20; TLoopX++) {
          blit(tile[Map[TLoopX + (User.offsetx)][TLoopY + (User.offsety)].l1], screenbmp, 0, 0, TLoopX * 16, TLoopY * 16, 16, 16);
          masked_blit(tile[Map[TLoopX + (User.offsetx)][TLoopY + (User.offsety)].l2], screenbmp, 0, 0, TLoopX * 16, TLoopY * 16, 16, 16);
       }
    }
    blit(screenbmp, screen, 0, 0, 0, 0, 320, 200);
    DrawExtras();
}

void LoadFile()
{
    FILE *oFile;
    if ((oFile = fopen("MAP\\MAP.DAT", "rb")) == NULL) {
       die ("Couldn't load MAP\\map.dat");
    }
    fread(&Map, sizeof(Map), 1, oFile);		//Read the entire map into the struct
    fclose(oFile);
    DrawMap();
};
