#include "startup.h"
#include <dpmi.h>
#include <stdio.h>
#include <stdarg.h>

#include <allegro.h>

void Startup()
{
    float freemem;
    __dpmi_free_mem_info meminfo;	//gets the amount of free mem

    printf("Final Fantasy Zero --> Build Pre Alpha .05 <---\n");
    printf("(c) 1998 Justin Heiner\n");
    printf("----------------------\n");

    allegro_init();		//Init basic allegro functions

    check_cpu();		//Checks what cpu you have

    install_keyboard();		//Installs keyboard routines

    printf("Keyboard Installed\n");

    install_timer();		//Installs timer routines

    printf("Timer Installed\n");

    switch (os_type)		//Prints out info about OS
     {
    case OSTYPE_UNKNOWN:
	{
	    printf("Running under MS-DOS *** Maximum performance guarenteed\n");
	    break;
	}
    case OSTYPE_WIN3:
	{
	    printf("Running under Windows 3.1 *** !!Warning!! Performance may suffer greatly\n");
	    break;
	}
    case OSTYPE_WIN95:
	{
	    printf("Running Under Windows 95 *** !!Warning!! Game may be unstable\n");
	    break;
	}
    }

    switch (cpu_family)		//Prints out info about CPU
     {
    case 3:
	{
	    printf("Intel 386 or compatible detected\n");
	    break;
	}
    case 4:
	{
	    printf("Intel 486 or compatible detected\n");
	    break;
	}
    case 5:
	{
	    printf("Intel Pentium or compatible detected\n");
	    break;
	}
    default:
	{
	    printf("Unknown CPU detected.... Game should still run...\n");
	    break;
	}
    }

    switch (cpu_fpu)		//detects FPU
     {
    case TRUE:
	{
	    printf("FPU detected\n");
	    break;
	}
    case FALSE:
	{
	    printf("FPU not detected\n");
	    break;
	}
    }

    __dpmi_get_free_memory_information(&meminfo);	//gets free memory

    freemem = (float) meminfo.largest_available_free_block_in_bytes;	//typecasts it to a float

    printf("Largest free memory block: %.2fMB\n", freemem / 1048576);	//prints it out :)

    printf("Press any key to continue\n");
    readkey();
    set_gfx_mode(GFX_VGA, 320, 200, 320, 200);

}
